import java.util.*;
import greenfoot.*;

public class Mars extends World
{
    private GreenfootImage gfImageBG;
    private Peetie peetie;
    private String hintergrundBild = "smartphone-peetie-app-388x700.jpg"; // anpassen bei Bedarf. Defaultbild marsoberflaeche-960.jpg
    public Mars()
    {
        super(388, 700, 1);
        /* --------------- SOUND ---------------- */
        Sound.initializeDefaultSounds(); // Darf nur zu Anfang passieren (--> statische Values)
        this.initializeWorld();
    }

    public void initializeWorld() {
        // Alle Objekte entfernen
        for(Actor a : (List<Actor>)this.getObjects(Actor.class)) {
            this.removeObject(a);
        }
        this.setBackground(this.hintergrundBild);

        this.peetie = new Peetie();
        this.addObject(this.peetie, this.peetie.getPeetieStartposX(), this.peetie.getPeetieStartposY());
        this.peetie.setImage("peetie_runter_50.png");

        this.objekteAufWeltSetzen();
        this.createUI();
        Greenfoot.delay(70);
    }

    public void objekteAufWeltSetzen()
    {
        // this.addObject(new Basis(), 450, 333);
    }

    public void started() {
        // alle Actor von der Welt entfernen
        List<Actor> actors = (List<Actor>)this.getObjects(Actor.class);
        for(Actor a : actors) {
            this.removeObject(a);
        }
        // Welt neu aufbauen
        this.initializeWorld();
        this.peetie.runOrganize(); // Auskommentieren, wenn Peetie erst nach Klick auf den UI-Run-Knopf anfangen soll
    }

    public void stopped() {
    }


    public void createUI() {

        /* --------------- TEXTE ENTFERNEN -------- */
        this.alleShowTextTexteLoeschen();

        /* --------------- BuTTONS ---------------- */
        this.buttonsZeigen();

        /* --------------- DIVERS (Logo …) ---------------- */
        Label logo = new Label();
        GreenfootImage g = new GreenfootImage("efm-logo-150x49.png");
        g.setTransparency(80);
        g.scale(g.getWidth()/2, g.getHeight()/2);
        logo.setImage(g);
        this.addObject(logo, 190,85);

        /* --------------- RASTER ---------------- */
        //  this.createGrid();
    }

    public void buttonsZeigen() { // Nur dann, wenn run-Methode nicht läuft (da sie nicht geklickt werden können, während Peetie run() ausführt)
        // name, shortcut, filestandard, filehover, fileinactive
        Button btRun = new Button("run", "r", "bt_start.png", "bt_start_clicked.png", null);
        this.addObject(btRun, this.getWidth()/2 - 35, 450);

        /* Button btSound = new Button("ton", "t", "bt_soundON.png", "bt_soundON_clicked.png", "bt_soundOFF_inactive.png");
        this.addObject(btSound, 65, 575);*/

        Button btAnleitung = new Button("help", "h", "bt_help.png", "bt_help_clicked.png", null);
        this.addObject(btAnleitung, this.getWidth()/2 + 35, 450);
    }

    public void buttonsVerstecken() { // während run-Methode läuft
        List<Button> buttonListe = (List<Button>)this.getObjects(Button.class);
        for(Button einButton : buttonListe) { this.removeObject(einButton); }
    }

    public void alleShowTextTexteLoeschen() {
        for(int x = 1; x <= this.getWidth(); x++) {
            for(int y = 1; y <= this.getHeight(); y++) {
                this.showText("", x, y);
            }
        }
    }

    public Peetie getPeetie() {
        return this.peetie;
    }

}
